VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "FloodFill"
   ClientHeight    =   4365
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4020
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4365
   ScaleWidth      =   4020
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox chkStyle 
      Caption         =   "&Iteration"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   4080
      Width           =   1815
   End
   Begin VB.PictureBox Pixel 
      BorderStyle     =   0  'Kein
      Height          =   200
      Index           =   0
      Left            =   0
      ScaleHeight     =   195
      ScaleWidth      =   195
      TabIndex        =   0
      Top             =   0
      Width           =   200
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Fr die Animation
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


Private Sub Form_Load()
   Call InitializeForm
End Sub

' Form einrichten
Public Sub InitializeForm()
   Dim x As Long, y As Long, cnt As Long
   
   Call Randomize

   For y = 0 To 19
      For x = 0 To 19
      
         If cnt <> 0 Then Call Load(Pixel(cnt))
         
         With Pixel(cnt)
            .Visible = True
            .Left = 200 * x
            .Top = 200 * y
         End With
         
         mPixel(x, y) = IIf(Int(Rnd * 100) Mod 3 = 0, vbBlack, vbWhite)
         
         cnt = cnt + 1
      Next x
   Next y

End Sub

' Vorgang auslsen
Private Sub Pixel_Click(Index As Integer)
   If chkStyle.Value = 0 Then
      Call FloodFillRec(Index Mod 20, Index \ 20)
   Else
      Call FloodFillIt(Index Mod 20, Index \ 20, New CoordStack)
   End If
End Sub

' "Pixelfarbe" beeinflussen
Public Property Get mPixel(ByVal x As Long, ByVal y As Long) As Long
   mPixel = Pixel(x + 20 * y).BackColor
End Property
Public Property Let mPixel(ByVal x As Long, ByVal y As Long, ByVal rhs As Long)
   Pixel(x + 20 * y).BackColor = rhs
End Property

' Rekursives FloodFill
Private Sub FloodFillRec(ByVal x As Long, ByVal y As Long)
   If x > 19 Or y > 19 Or x < 0 Or y < 0 Then Exit Sub
   
   If mPixel(x, y) = vbWhite Then
      mPixel(x, y) = vbBlue
      
      Call Sleep(25)
      DoEvents
            
      Call FloodFillRec(x, y + 1)
      Call FloodFillRec(x, y - 1)
      Call FloodFillRec(x + 1, y)
      Call FloodFillRec(x - 1, y)
      
   End If
End Sub

' Iteratives FloodFill
Private Sub FloodFillIt(ByVal x As Long, ByVal y As Long, Stack As CoordStack)
   Call Stack.Push(x, y)
   
   Do While Not Stack.IsEmpty
      Call Stack.Pop(x, y)
      
      If mPixel(x, y) = vbWhite Then
         mPixel(x, y) = vbGreen
         
         DoEvents
         Call Sleep(25)
         
         Call Stack.Push(x, y + 1)
         Call Stack.Push(x, y - 1)
         Call Stack.Push(x + 1, y)
         Call Stack.Push(x - 1, y)
                  
      End If
   Loop
End Sub


